

set multiplot layout 5,1
set grid
set style line 1  linecolor rgb "red"  linewidth 3.000 pointtype 2 dashtype 2 pointsize default pointinterval 0
set style line 2  linecolor rgb "orange"  linewidth 2.000 pointtype 2 dashtype 2 pointsize default pointinterval 0
set style line 3  linecolor rgb "yellow"  linewidth 3.000 pointtype 2 dashtype 2 pointsize default pointinterval 0
set style line 4  linecolor rgb "green"  linewidth 2.000 pointtype 2 dashtype 2 pointsize default pointinterval 0

set style function linespoints

unset colorbox
 plot  [00:1000.00] "datfiles/sin.save" with line lt 2 lw 1 title 'sin car.dat'
 plot  [00:1000.00] "datfiles/cos.save" with line lt 1 lw 1 title 'cos car.dat'
 plot  [00:1000.00] "datfiles/insig.save" with line lt 2 lw 1 title 'insig.dat'
 plot  [00:1000.00] "datfiles/upper.save" with line lt 1 lw 1 title 'uppersb.dat'
 plot  [00:1000.00] "datfiles/lower.save" with line lt 2 lw 1 title 'lowersb.dat'

unset multiplot
