//J. Hearon
// placing sin values into a vector

//g++ -I /usr/include/gmm/ gmm1.cpp -o test1

#include <iostream>
#include <math.h>
#include <gmm.h>

#define SIZE 10
#define N 11
int main()
{

std::vector<double> V(N);
gmm::clear(V);

for (int s=0;s<SIZE;s++) {
    V[s] = sin(s);
    }
std::cout << " Vector V: "  << V << std::endl;
}

//Vector V: vector(11) [ 0, 0.841471, 0.909297, 0.14112, -0.756802, -0.958924, -0.279415, 0.656987, 0.989358, 0.412118, 0 ]
