<Cabbage>
form size(350,150), caption("Basic Stroboscopic Effect")
encoder bounds( 70, 10,100,100), channel("PhsRate"), text("Phase Rate"), textbox(1), value(15.777), sliderincr(0.001)
encoder bounds(180, 10,100,100), channel("SHrate"), text("S&H.Rate"), textbox(1), value(6), sliderincr(0.01)
</Cabbage>

<CsoundSynthesizer>

<CsOptions>
-n -dm0
</CsOptions>

<CsInstruments>

sr = 44100
ksmps = 16
nchnls = 2
0dbfs = 1

instr   1
 kPhsRate chnget    "PhsRate"
 kSHrate  chnget    "SHrate"
 kSHTrig  metro     kSHrate           ; train of triggers
 aphs     phasor    kPhsRate          ; a phase vector moving from 0 - 1
 aoct     samphold  aphs + 7, kSHTrig ; repeatedly sample and hold phasor
 asig     poscil    0.2, cpsoct(aoct) ; sonify samp&hold signal
          outs      asig, asig
endin

</CsInstruments>

<CsScore>
i 1 0 3600
</CsScore>

</CsoundSynthesizer>