
<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odac:hw:0,0 -b1024 -B16384
;csound -g -+rtaudio=ALSA -otest.wav -b1024 -B16384
;csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384  
</CsOptions>
<CsInstruments>

sr=44100
kr=1
;ksmps=44100
nchnls=2
0dbfs = 1

ginum init  44100
givr  la_i_vr_create  ginum
gitablenum1 ftgen 100, 0, -44100, 7, 0, 44100, 0
	

	instr 1 ; 400 Hz Sine
krow init 0
kcntr init 0
kvalue init 0
itwopi=3.14
ifreq = 400

reset:
givr    la_k_vr_set  krow, kvalue                  
krow = krow+1
kvalue = sin(itwopi*kcntr/(sr/2)*ifreq)
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
	endin

	instr 2;--Assign to asig and listen
asig  la_k_a_assign   givr
outs asig * .7, asig * .7
	endin

	instr 3 ; assign to table for printing
gitablenum1    la_i_t_assign         givr
	endin

	instr 4;--Save table
 ftsave "sine_la.save", 1, 100
	endin

</CsInstruments>
<CsScore>
i1  1  1
i2  2  2
i3  4  1
i4  5  1
e

</CsScore>
</CsoundSynthesizer>


