;J. Hearon
<CsoundSynthesizer>
<CsOptions>
csound -g -d -+rtaudio=ALSA -odac:hw:0,0 -b1024 -B16384
;csound -g -d -+rtaudio=ALSA -o devaudio -b1024 -B16384
;csound -g -+rtaudio=ALSA -o/opt/csound6-git/spline/wavfiles/splines.wav -b1024 -B16384
</CsOptions>
<CsInstruments>

sr=44100
ksmps = 32
nchnls=2
0dbfs = 1
;------------
;-------------
;CREATE GLOBALS
;------------
;------------

gisine ftgen 10, 0, 16384, 10, 1  ;sine
gione ftgen 1, 0, 65, 8, 0, 32, 1, 33, 0  ;GEN08 envelope
gitwo ftgen 2, 0, 65, 8, 0, 32, 0, 33, 1 
githree ftgen 3, 0, 65, 8, 0, 16, 1, 16, 0, 16, 0, 17, 1
gifour ftgen 4, 0, 65, 8, 0, 16, 0, 16, 1, 16, 0, 17, 1

gimr_matrix	   la_i_mr_create        2, 2

;------------
;-------------
;Set MATRIX of table numbers and print
;------------
;------------
gimr_matrix	 la_i_mr_set   0, 0, 1  
gimr_matrix	 la_i_mr_set   0, 1, 2

gimr_matrix	 la_i_mr_set   1, 0, 3  
gimr_matrix	 la_i_mr_set   1, 1, 4  

prints "\n*** 2x2 matrix***\n"
la_i_print_mr    gimr_matrix

;------------
;-------------
;DO LOOP to extract matrix values as table numbers and
;schedule an instrument to implement the GEN08 values applied to freq
;------------
;------------
	instr 1
irows, icolumns  la_i_size_mr   gimr_matrix
;printf_i  "gimr_matrix irows: '%d' icolumns: '%d'\n", 1, irows, icolumns
icntr init 1
irow init 0
icolumn init 0

until icntr > irows * icolumns do 
	ivalue   la_i_get_mr   gimr_matrix, irow, icolumn
	;print icntr, irow, icolumn, ivalue;

	schedule 10, ivalue, 1, 9.00 + (0.01 * ivalue), ivalue

	if (icolumn == icolumns - 1)then
		irow = irow + 1;
        	icolumn = -1;
        	igoto cont;
        	endif;
cont:
icolumn = icolumn+1
icntr = icntr + 1
od
      endin
;------------
	instr 10
ifn  = p5					;get function table number
kcps init 1/p3					;create index over duration of note.
kndx phasor kcps
ixmode = 1
kval table kndx, p5, ixmode			;get the table data
kfreq = kval * 100				;scale the data
aspline  poscil .7,  cpspch(p4) + kfreq, 1	;and data to frequency
      outs aspline, aspline
	endin
;------------

;</CsInstruments>
;</CsoundSynthesizer>

</CsInstruments>
<CsScore>
i1 1  6
e
</CsScore>
</CsoundSynthesizer>

